// EE231002 Lab10. Word Processing
// 108061112, 林靖
// Nov. 30, 2019

#include <stdio.h>
#include <string.h>

#define PN 1000
#define PW 80
#define LN 52
#define CW 38

int read_line(char para[PN + 1]);
int split(const char para[PN + 1], char outBuffer[LN][CW + 1]);

int main(void)
{
	char para[PN + 1];
	char outBuffer[LN][CW + 1] = {'\0'};
	int half;
	int line;
	int space;

	while (read_line(para)) {
		putchar('\n');
		if ((half = split(para, outBuffer) / 2 + 0.5)) {
			for (line = 0; line < half; line++) {
				for (space = CW - strlen(outBuffer[line]); space; space--)
					putchar(' ');
				printf(outBuffer[line]);
				printf(" | ");
				puts(outBuffer[line + half]);
			}
		}
	}
	return 0;
}

int read_line(char para[PN + 1])
{
	char *p = para;
	char *end = para + PN;

	for ( ; p < end && (*p = getchar()) != '\n'; p++) ;
	if (*p == EOF)
		return 0;
	while (p < end)
		*p++ = '\0';
	return 1;
}

int split(const char para[], char outBuffer[LN][CW + 1])
{
	int i = 0;
	int j = 0;
	int line;

	if (para[0] == '\0')
		return 0;
	for (line = 0; line < LN; line++) {
		for (j = i + CW; para[j] != ' '; j--) ;
		if (j < i)
			return line;
		for (j--; j >= i; j--)
			outBuffer[line][j - i] = para[j];
		j++;
		i += 1 + strlen(outBuffer[line]);
	}
	return line;
}
